diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index d9df13fac..6bc6a97b5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -567,186 +592,234 @@ public class ScreenAchievements extends Screen
 //            long seed = Objects.hash(l1, l2, ~l3);
 //            random.setSeed(seed);
 
-            for (BGLayer layer : layers) {
+            for (BGLayer layer : this.layers) {
                 random.setSeed(worldSeed);
-                currentPage.postProcessBackground(this, random, layer, orgX + viewTileX, orgY + viewTileY);
+                this.currentPage.postProcessBackground(this, random, layer, orgX + viewTileX, orgY + viewTileY);
             }
         }
 
 
-
-        for(int _y = 0; _y < tilesTall; _y++) {
-            int tileY = orgY + _y + viewTileY;
-            float brightness = 0.6F - ((float)(tileY) / 25F) * 0.3F;
-            for(int _x = 0; _x < tilesWide; _x++) {
-                int tileX = orgX + _x + viewTileX;
-
-                for (int i = layers.length - 1; i >= 0; i--) {
-                    BGLayer topLayer = getLayer(i);
-                    IconCoordinate fore = topLayer.get(_x, _y);
-
-                    IconCoordinate next = null;
-                    if (i - 1 >= 0) {
-                        BGLayer nextLayer = getLayer(i - 1);
-                        next = nextLayer.get(_x, _y);
-                    }
-
-
-                    boolean bottom = false;
-                    boolean top = false;
-                    boolean left = false;
-                    boolean right = false;
-                    boolean topLeft = false;
-                    boolean topRight = false;
-                    boolean bottomLeft = false;
-                    boolean bottomRight = false;
-
-
-                    if (fore != null && next == null && i - 1 >= 0) {
-                        BGLayer nextLayer = getLayer(i - 1);
-                        top = nextLayer.get(_x, _y - 1) != null;
-                        left = nextLayer.get(_x - 1, _y) != null;
-                        right = nextLayer.get(_x + 1, _y) != null;
-                        bottom = nextLayer.get(_x, _y + 1) != null;
-                        topLeft = nextLayer.get(_x - 1, _y - 1) != null;
-                        topRight = nextLayer.get(_x + 1, _y - 1) != null;
-                        bottomLeft = nextLayer.get(_x - 1, _y + 1) != null;
-                        bottomRight = nextLayer.get(_x + 1, _y + 1) != null;
-                    }
-
-                    double iconLeft = (viewportLeft + viewportWidth / 2d) + zoom * (((orgX + _x) * TILE_WIDTH) - remainderX);
-                    double iconTop = (viewportTop + viewportHeight / 2d) + zoom * (((orgY + _y) * TILE_HEIGHT) - remainderY);
-                    double iconWidth = TILE_WIDTH * zoom;
-                    double iconHeight = TILE_HEIGHT * zoom;
-
-                    if (fore != null) {
-                        float shadowScale = (float) Math.pow(0.65f, i);
-                        if (next != null) {
-                            shadowScale *= 0.5f;
+        if (dirty) {
+            for (int renderpass = 0; renderpass < 2; renderpass++) {
+                TessellatorGeneral t = GLRenderer.getTessellator();
+                if (renderpass == 0) {
+                    t.startDrawingQuads();
+                } else {
+                    t.startDrawing(DrawMode.TRIANGLES);
+                }
+                for(int _y = 0; _y < tilesTall; _y++) {
+                    int tileY = orgY + _y + viewTileY;
+                    float brightness = 0.6F - ((float)(tileY) / 25F) * 0.3F;
+                    for(int _x = 0; _x < tilesWide; _x++) {
+                        int tileX = orgX + _x + viewTileX;
+
+                        for (int i = this.layers.length - 1; i >= 0; i--) {
+                            BGLayer topLayer = getLayer(i);
+                            IconCoordinate fore = topLayer.get(_x, _y);
+
+                            IconCoordinate next = null;
+                            if (i - 1 >= 0) {
+                                BGLayer nextLayer = getLayer(i - 1);
+                                next = nextLayer.get(_x, _y);
+                            }
+
+
+                            boolean bottom = false;
+                            boolean top = false;
+                            boolean left = false;
+                            boolean right = false;
+                            boolean topLeft = false;
+                            boolean topRight = false;
+                            boolean bottomLeft = false;
+                            boolean bottomRight = false;
+
+
+                            if (fore != null && next == null && i - 1 >= 0) {
+                                BGLayer nextLayer = getLayer(i - 1);
+                                top = nextLayer.get(_x, _y - 1) != null;
+                                left = nextLayer.get(_x - 1, _y) != null;
+                                right = nextLayer.get(_x + 1, _y) != null;
+                                bottom = nextLayer.get(_x, _y + 1) != null;
+                                topLeft = nextLayer.get(_x - 1, _y - 1) != null;
+                                topRight = nextLayer.get(_x + 1, _y - 1) != null;
+                                bottomLeft = nextLayer.get(_x - 1, _y + 1) != null;
+                                bottomRight = nextLayer.get(_x + 1, _y + 1) != null;
+                            }
+
+                            double iconLeft = _x * TILE_WIDTH;
+                            double iconTop = _y * TILE_WIDTH;
+                            double iconWidth = TILE_WIDTH;
+                            double iconHeight = TILE_HEIGHT;
+
+
+                            if (renderpass == 0) { // Background block tile quads pass
+                                if (fore != null) {
+                                    float shadowScale = (float) Math.pow(0.65f, i);
+                                    if (next != null) {
+                                        shadowScale *= 0.5f;
+                                    }
+                                    t.setColor4f(brightness * shadowScale, brightness * shadowScale, brightness * shadowScale, 1.0F);
+                                    addGuiIconDouble(t, iconLeft, iconTop, iconWidth, iconHeight, fore);
+                                }
+                            } else { // Background shadow tri pass
+                                final double off = 0;
+                                double fadeDist = 6 * zoom;
+                                short shadowDarkness = 128;
+
+                                if (top) {
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft - off, iconTop + fadeDist + off, 0.0D);
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + iconWidth + off, iconTop + fadeDist + off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft - off, iconTop - off, 0.0D);
+
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft - off, iconTop - off, 0.0D);
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + iconWidth + off, iconTop + fadeDist + off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft + iconWidth + off, iconTop - off, 0.0D);
+                                }
+                                if (left) {
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + fadeDist + off, iconTop + iconHeight + off, 0.0D);
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + fadeDist + off, iconTop - off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft - off, iconTop + iconHeight + off, 0.0D);
+
+
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft - off, iconTop + iconHeight + off, 0.0D);
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + fadeDist + off, iconTop - off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft - off, iconTop - off, 0.0D);
+                                }
+                                if (bottom) {
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + iconWidth + off, iconTop + iconHeight - fadeDist + off, 0.0D);
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft - off, iconTop + iconHeight - fadeDist + off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft + iconWidth + off, iconTop + iconHeight - off, 0.0D);
+
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft + iconWidth + off, iconTop + iconHeight - off, 0.0D);
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft - off, iconTop + iconHeight - fadeDist + off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft - off, iconTop + iconHeight - off, 0.0D);
+                                }
+                                if (right) {
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + iconWidth - fadeDist + off, iconTop - off, 0.0D);
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + iconWidth - fadeDist + off, iconTop + iconHeight + off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft + iconWidth - off, iconTop - off, 0.0D);
+
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft + iconWidth - off, iconTop - off, 0.0D);
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + iconWidth - fadeDist + off, iconTop + iconHeight + off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft + iconWidth - off, iconTop + iconHeight + off, 0.0D);
+                                }
+                                if (topLeft && !(left || top)) {
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft - off, iconTop + fadeDist + off, 0.0D);
+                                    t.addVertex(iconLeft + fadeDist + off, iconTop - off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft - off, iconTop - off, 0.0D);
+                                }
+                                if (topRight && !(right || top)) {
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + iconWidth - fadeDist + off, iconTop - off, 0.0D);
+                                    t.addVertex(iconLeft + iconWidth - off, iconTop + fadeDist + off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft + iconWidth - off, iconTop - off, 0.0D);
+                                }
+                                if (bottomLeft && !(left || bottom)) {
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + fadeDist + off, iconTop + iconHeight - off, 0.0D);
+                                    t.addVertex(iconLeft - off, iconTop + iconHeight - fadeDist + off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft - off, iconTop + iconHeight - off, 0.0D);
+                                }
+                                if (bottomRight && !(right || bottom)) {
+                                    t.setColor2i(0, 0);
+                                    t.addVertex(iconLeft + iconWidth - off, iconTop + iconHeight - fadeDist + off, 0.0D);
+                                    t.addVertex(iconLeft + iconWidth - fadeDist + off, iconTop + iconHeight - off, 0.0D);
+                                    t.setColor2i(0, shadowDarkness);
+                                    t.addVertex(iconLeft + iconWidth - off, iconTop + iconHeight - off, 0.0D);
+                                }
+                            }
                         }
-                        GL11.glColor4f(brightness * shadowScale, brightness * shadowScale, brightness * shadowScale, 1.0F);
-                        final double epsilon = 0.05;
-                        drawGuiIconDouble(iconLeft - epsilon, iconTop - epsilon, iconWidth + epsilon * 2, iconHeight + epsilon * 2, fore);
-                    }
-
-                    GL11.glDisable(GL11.GL_TEXTURE_2D);
-                    GL11.glEnable(GL11.GL_BLEND);
-                    GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-                    GL11.glDisable(GL11.GL_ALPHA_TEST);
-                    GL11.glShadeModel(GL11.GL_SMOOTH);
-                    Tessellator t = Tessellator.instance;
-                    final double off = 0.05d;
-                    double fadeDist = 6 * zoom;
-                    short shadowDarkness = 128;
-                    if (top) {
-                        t.startDrawingQuads();
-                        t.setColorRGBA_I(0, 0);
-                        t.addVertexWithUV(iconLeft - off, iconTop + fadeDist + off, 0.0D, 0.0D, 1.0D);
-                        t.addVertexWithUV(iconLeft + iconWidth + off, iconTop + fadeDist + off, 0.0D, 1.0D, 1.0D);
-                        t.setColorRGBA_I(0, shadowDarkness);
-                        t.addVertexWithUV(iconLeft + iconWidth + off, iconTop - off, 0.0D, 1.0D, 0.0D);
-                        t.addVertexWithUV(iconLeft - off, iconTop - off, 0.0D, 0.0D, 0.0D);
-                        t.draw();
-                    }
-                    if (left) {
-                        t.startDrawingQuads();
-                        t.setColorRGBA_I(0, 0);
-                        t.addVertexWithUV(iconLeft + fadeDist + off, iconTop + iconHeight + off, 0.0D, 1.0D, 1.0D);
-                        t.addVertexWithUV(iconLeft + fadeDist + off, iconTop - off, 0.0D, 0.0D, 1.0D);
-                        t.setColorRGBA_I(0, shadowDarkness);
-                        t.addVertexWithUV(iconLeft - off, iconTop - off, 0.0D, 0.0D, 0.0D);
-                        t.addVertexWithUV(iconLeft - off, iconTop + iconHeight + off, 0.0D, 1.0D, 0.0D);
-                        t.draw();
                     }
-                    if (bottom) {
-                        t.startDrawingQuads();
-                        t.setColorRGBA_I(0, 0);
-                        t.addVertexWithUV(iconLeft + iconWidth + off, iconTop + iconHeight - fadeDist + off, 0.0D, 1.0D, 1.0D);
-                        t.addVertexWithUV(iconLeft - off, iconTop + iconHeight - fadeDist + off, 0.0D, 0.0D, 1.0D);
-                        t.setColorRGBA_I(0, shadowDarkness);
-                        t.addVertexWithUV(iconLeft - off, iconTop + iconHeight - off, 0.0D, 0.0D, 0.0D);
-                        t.addVertexWithUV(iconLeft + iconWidth + off, iconTop + iconHeight - off, 0.0D, 1.0D, 0.0D);
-                        t.draw();
-                    }
-                    if (right) {
-                        t.startDrawingQuads();
-                        t.setColorRGBA_I(0, 0);
-                        t.addVertexWithUV(iconLeft + iconWidth - fadeDist + off, iconTop - off, 0.0D, 0.0D, 1.0D);
-                        t.addVertexWithUV(iconLeft + iconWidth - fadeDist + off, iconTop + iconHeight + off, 0.0D, 1.0D, 1.0D);
-                        t.setColorRGBA_I(0, shadowDarkness);
-                        t.addVertexWithUV(iconLeft + iconWidth - off, iconTop + iconHeight + off, 0.0D, 1.0D, 0.0D);
-                        t.addVertexWithUV(iconLeft + iconWidth - off, iconTop - off, 0.0D, 0.0D, 0.0D);
-                        t.draw();
-                    }
-                    if (topLeft && !(left || top)) {
-                        t.startDrawing(GL11.GL_TRIANGLES);
-                        t.setColorRGBA_I(0, 0);
-                        t.addVertexWithUV(iconLeft - off, iconTop + fadeDist + off, 0.0D, 1.0D, 0.0D);
-                        t.addVertexWithUV(iconLeft + fadeDist + off, iconTop - off, 0.0D, 0.0D, 0.0D);
-                        t.setColorRGBA_I(0, shadowDarkness);
-                        t.addVertexWithUV(iconLeft - off, iconTop - off, 0.0D, 0.0D, 1.0D);
-                        t.draw();
-                    }
-                    if (topRight && !(right || top)) {
-                        t.startDrawing(GL11.GL_TRIANGLES);
-                        t.setColorRGBA_I(0, 0);
-                        t.addVertexWithUV(iconLeft + iconWidth - fadeDist + off, iconTop - off, 0.0D, 0.0D, 0.0D);
-                        t.addVertexWithUV(iconLeft + iconWidth - off, iconTop + fadeDist + off, 0.0D, 1.0D, 0.0D);
-                        t.setColorRGBA_I(0, shadowDarkness);
-                        t.addVertexWithUV(iconLeft + iconWidth - off, iconTop - off, 0.0D, 0.0D, 1.0D);
-                        t.draw();
-                    }
-                    if (bottomLeft && !(left || bottom)) {
-                        t.startDrawing(GL11.GL_TRIANGLES);
-                        t.setColorRGBA_I(0, 0);
-                        t.addVertexWithUV(iconLeft + fadeDist + off, iconTop + iconHeight - off, 0.0D, 0.0D, 0.0D);
-                        t.addVertexWithUV(iconLeft - off, iconTop + iconHeight - fadeDist + off, 0.0D, 1.0D, 0.0D);
-                        t.setColorRGBA_I(0, shadowDarkness);
-                        t.addVertexWithUV(iconLeft - off, iconTop + iconHeight - off, 0.0D, 0.0D, 1.0D);
-                        t.draw();
+                }
+                if (renderpass == 0) {
+                    if (this.lastBackgroundTileBuf == null) {
+                        this.lastBackgroundTileBuf = t.record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
+                    } else {
+                        this.lastBackgroundTileBuf = t.record(this.lastBackgroundTileBuf.vao(), this.lastBackgroundTileBuf.vbo());
                     }
-                    if (bottomRight && !(right || bottom)) {
-                        t.startDrawing(GL11.GL_TRIANGLES);
-                        t.setColorRGBA_I(0, 0);
-                        t.addVertexWithUV(iconLeft + iconWidth - off, iconTop + iconHeight - fadeDist + off, 0.0D, 1.0D, 0.0D);
-                        t.addVertexWithUV(iconLeft + iconWidth - fadeDist + off, iconTop + iconHeight - off, 0.0D, 0.0D, 0.0D);
-                        t.setColorRGBA_I(0, shadowDarkness);
-                        t.addVertexWithUV(iconLeft + iconWidth - off, iconTop + iconHeight - off, 0.0D, 0.0D, 1.0D);
-                        t.draw();
+                } else {
+                    if (this.lastBackgroundShadowBuf == null) {
+                        this.lastBackgroundShadowBuf = t.record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
+                    } else {
+                        this.lastBackgroundShadowBuf = t.record(this.lastBackgroundShadowBuf.vao(), this.lastBackgroundShadowBuf.vbo());
                     }
-                    GL11.glEnable(GL_TEXTURE_2D);
-                    GL11.glEnable(GL11.GL_ALPHA_TEST);
                 }
             }
         }
+        double iconLeft = (this.viewportLeft + this.viewportWidth / 2d) + zoom * (orgX * TILE_WIDTH) - zoom * remainderX;
+        double iconTop = (this.viewportTop + this.viewportHeight / 2d) + zoom * ((orgY * TILE_HEIGHT) - remainderY);
+
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) iconLeft, (float) iconTop,0).scale((float) zoom, (float) zoom, 1);
+        if (this.lastBackgroundTileBuf != null) {
+            TextureRegistry.worldAtlas.bind();
+            GLRenderer.render(this.lastBackgroundTileBuf);
+        }
+        if (this.lastBackgroundShadowBuf != null) {
+            GLRenderer.pushFrame();
+            GLRenderer.setShader(Shaders.COLOR);
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.render(this.lastBackgroundShadowBuf);
+            GLRenderer.popFrame();
+        }
+        GLRenderer.popFrame();
     }
 
     public BGLayer getLayer(int layer){
-        if (layer < 0 || layer >= layers.length) return null;
-        return layers[layer];
+        if (layer < 0 || layer >= this.layers.length) return null;
+        return this.layers[layer];
     }
 
     private double timeSin(double amplitude, long period){
         return Math.sin(((double)(System.currentTimeMillis() % period) / period) * Math.PI * 2D) * amplitude;
     }
     private void drawConnectingLines(int mouseX, int mouseY, double shiftX, double shiftY){
-        double zoom = viewportZoom;
+        double zoom = this.viewportZoom;
 
-        for(AchievementPage.AchievementEntry entry : currentPage.getAchievementEntries()) {
+        for(AchievementPage.AchievementEntry entry : this.currentPage.getAchievementEntries()) {
             Achievement ach = entry.achievement;
-            AchievementPage.AchievementEntry parentEntry = currentPage.getEntry(ach.parent);
+            AchievementPage.AchievementEntry parentEntry = this.currentPage.getEntry(ach.parent);
             if(parentEntry == null) {
                 continue;
             }
-            if (!currentPage.hasAchievement(ach) || !currentPage.hasAchievement(ach.parent)){
+            if (!this.currentPage.hasAchievement(ach) || !this.currentPage.hasAchievement(ach.parent)){
                 continue;
             }
-            double childX = (viewportLeft + viewportWidth/2d) + ((entry.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
-            double childY = (viewportTop + viewportHeight/2d) + ((entry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
-            double parentX = (viewportLeft + viewportWidth/2d) + ((parentEntry.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
-            double parentY = (viewportTop + viewportHeight/2d) + ((parentEntry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
-            boolean unlocked = statsCounter.isUnlocked(ach);
-            boolean canUnlock = statsCounter.canUnlock(ach);
+            double childX = (this.viewportLeft + this.viewportWidth /2d) + ((entry.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
+            double childY = (this.viewportTop + this.viewportHeight /2d) + ((entry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
+            double parentX = (this.viewportLeft + this.viewportWidth /2d) + ((parentEntry.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
+            double parentY = (this.viewportTop + this.viewportHeight /2d) + ((parentEntry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
+            boolean unlocked = this.statsCounter.isUnlocked(ach);
+            boolean canUnlock = this.statsCounter.canUnlock(ach);
 
             final double zoomOff = 11 * zoom;
 //            if (
@@ -759,14 +832,14 @@ public class ScreenAchievements extends Screen
             {
                 double x = parentX - zoomOff;
                 double y = parentY - zoomOff;
-                if ((mouseX >= 0 && mouseY >= viewportTop && mouseX < width && mouseY < viewportBottom) && // In viewport and
+                if ((mouseX >= 0 && mouseY >= this.viewportTop && mouseX < this.width && mouseY < this.viewportBottom) && // In viewport and
                     (mouseX >= x && mouseX <= x + 22 * zoom && mouseY >= y && mouseY <= y + 22 * zoom)) { // Hovering over achievement
                     isHovered = true;
                 }
 
                 x = childX - zoomOff;
                 y = childY - zoomOff;
-                if ((mouseX >= 0 && mouseY >= viewportTop && mouseX < width && mouseY < viewportBottom) && // In viewport and
+                if ((mouseX >= 0 && mouseY >= this.viewportTop && mouseX < this.width && mouseY < this.viewportBottom) && // In viewport and
                     (mouseX >= x && mouseX <= x + 22 * zoom && mouseY >= y && mouseY <= y + 22 * zoom)) { // Hovering over achievement
                     isHovered = true;
                 }
@@ -774,12 +847,12 @@ public class ScreenAchievements extends Screen
 
             int color;
             if(unlocked) {
-                color = 0xff << Color.SHIFT_ALPHA | (currentPage.lineColorUnlocked(isHovered) & 0xffffff);
+                color = 0xff << Color.SHIFT_ALPHA | (this.currentPage.lineColorUnlocked(isHovered) & 0xffffff);
             } else if (canUnlock) {
                 int alpha = timeSin(1, 600) >= 0.6 ? 0x82 : 0xff;
-                color = (alpha << Color.SHIFT_ALPHA) | (currentPage.lineColorCanUnlock(isHovered) & 0xffffff);
+                color = (alpha << Color.SHIFT_ALPHA) | (this.currentPage.lineColorCanUnlock(isHovered) & 0xffffff);
             } else {
-                color = 0xff << Color.SHIFT_ALPHA | (currentPage.lineColorLocked(isHovered) & 0xffffff);
+                color = 0xff << Color.SHIFT_ALPHA | (this.currentPage.lineColorLocked(isHovered) & 0xffffff);
             }
 
             drawLineHorizontalDouble(childX, parentX, childY, color);
